//*******************************************************************************
//	Name	:	WFDialog.hxx
//			:	Common File Dialog functions
//	Author	:	I. Nakagawa
//	Create	:	2021/06/08
//	Modify	:	2021/07/02		bug	ini_fold
//	Modify	:	2021/09/28		bug	buffer empty
//	Modify	:	2024/12/03		
//*******************************************************************************

#pragma		once

#include	<iostream>
#include	"i_def_aw.hxx"
#include	"existff.hxx"
#include	"filepath.hxx"
#include	"stringto.hxx"
#include	"str_chg.hxx"
#include	"str_trim.hxx"
#include	"t_tstrng.hxx"
#include	"def_OFN.hxx"

////
//	*******************************************************************************
//	GetOpenFileName
//	Create	:	2021/06/08
//	Modify	:	2021/07/02		bug	ini_fold
//	Modify	:	2021/09/28		bug	buffer empty
//	*******************************************************************************
inline	tstring	FD_GetOpenFile	(
		HWND	hwnd
,		LPCTSTR	default_name	=	_T("")
,		LPCTSTR	filter_			=	OFN_filter_All
,		LPCTSTR title_			=	_T("Open")
		)
{
	tstring	str_file = default_name ;
//	if (::File_IsNothing(str_file)) 
	{
			str_file.erase() ;
			}
			str_file.resize(260*100) ;
	tstring	ini_fold = default_name ;
	if (!ini_fold.empty()) {
		if (!::File_IsDirectory(default_name))	{	ini_fold = ::Path_GetDir(default_name) ;	}
		else									{	ini_fold = 	             default_name ; 	}
		if (::File_IsNothing(ini_fold)) {
			ini_fold.erase() ;
			}
		}
	tstring	filter = filter_ ;
	if (filter.empty()) {
			filter = OFN_filter_All ;
			}
			filter   = ::String_Change(filter,_T('|'),_T('\x0')) ;
	tstring	title  = title_ ;
	{
		if (ini_fold.size() == 0)	{	ini_fold.resize(1) ;	}
		if (title.   size() == 0)	{	title.   resize(1) ;	}
		if (filter.  size() == 0)	{	filter.  resize(1) ;	}
		}
	OPENFILENAME	ofn =	{	0	} ;
	{
		ofn.lStructSize		= sizeof(OPENFILENAME) ;
		ofn.hwndOwner		= hwnd ;
		ofn.Flags			= OFN_HIDEREADONLY ;
		ofn.lpstrInitialDir	= &ini_fold[0] ;
		ofn.lpstrTitle		= &title[0] ;
		ofn.lpstrFilter		= &filter[0] ;
		ofn.lpstrFile		= &str_file[0] ;
		ofn.nMaxFile		= DWORD(str_file.size()) ;
		}
	if (!::GetOpenFileName(&ofn))		{
		DWORD	err = ::CommDlgExtendedError() ;
		if (err != 0) {
			std::terr << ::To_tstring(u_32(err),16) << std::endl ;
			}
		return	tstring() ;
		}
	tstring	sel_file ;
	{
		sel_file = ofn.lpstrFile ;
		}
	return	sel_file ;
	}

////
//	*******************************************************************************
//	GetOpenFileName	OFN_ALLOWMULTISELECT
//	Create	:	2021/06/08
//	Modify	:	2021/07/02		bug	ini_fold
//	Modify	:	2021/09/28		bug	buffer empty
//	*******************************************************************************
inline	v_tstring	FD_GetOpenFiles	(
		HWND	hwnd
,		LPCTSTR	default_name	=	_T("")
,		LPCTSTR	filter_			=	OFN_filter_All
,		LPCTSTR title_			=	_T("Open")
		)
{
	tstring	str_file = default_name ;
//	if (::File_IsNothing(str_file)) 
	{
			str_file.erase() ;
			}
			str_file.resize(260*100) ;
	tstring	ini_fold = default_name ;
	if (!ini_fold.empty()) {
		if (!::File_IsDirectory(default_name))	{	ini_fold = ::Path_GetDir(default_name) ;	}
		else									{	ini_fold = 	             default_name ; 	}
		if (::File_IsNothing(ini_fold)) {
			ini_fold.erase() ;
			}
		}
	tstring	filter = filter_ ;
	if (filter.empty()) {
			filter = OFN_filter_All ;
			}
			filter = ::String_Change(filter,_T('|'),_T('\x0')) ;
	tstring	title  = title_ ;
	{
		if (ini_fold.size() == 0)	{	ini_fold.resize(1) ;	}
		if (title.   size() == 0)	{	title.   resize(1) ;	}
		if (filter.  size() == 0)	{	filter.  resize(1) ;	}
		}
	OPENFILENAME	ofn =	{	0	} ;
	{
		ofn.lStructSize	= sizeof(OPENFILENAME) ;
		ofn.hwndOwner	= hwnd ;
		ofn.Flags		= OFN_ALLOWMULTISELECT | OFN_EXPLORER | OFN_HIDEREADONLY ;
		ofn.lpstrInitialDir	= &ini_fold[0] ;
		ofn.lpstrTitle	= &title[0] ;
		ofn.lpstrFilter	= &filter[0] ;
		ofn.lpstrFile	= &str_file[0] ;
		ofn.nMaxFile	= DWORD(str_file.size()) ;
		}
	if (!::GetOpenFileName(&ofn))		{
		DWORD	err = ::CommDlgExtendedError() ;
		if (err != 0) {
			std::terr << ::To_tstring(u_32(err),16) << std::endl ;
			}
		return	v_tstring() ;
		}
	tstring	sel_file ;
	{
		sel_file = ofn.lpstrFile ;
		sel_file = str_file ;
		sel_file = ::String_Change(ofn.lpstrFile,_T('\x0'),_T('\n')) ;
		sel_file = ::String_Change(str_file,     _T('\x0'),_T('\n')) ;
		sel_file = ::String_TrimBoth(sel_file) ;
		}
	v_tstring	file_names ;
	{
		v_tstring	fold_file = ::String_SplitLine(sel_file.c_str(),false) ;
		if		(fold_file.size() == 1)		{	file_names.push_back(fold_file[0]) ;	}
		else if (fold_file.size() >  1)		{
			tstring		fold = fold_file[0] ;
			for (size_t index=1 ; index<fold_file.size() ; index++) {
				tstring	file_name = ::Path_AddLastSP(fold) + fold_file[index] ;
				file_names.push_back(file_name) ;
				}
			}
		}
	return	file_names ;
	}

////
//	*******************************************************************************
//	GetSaveFileName
//	Create	:	2021/06/08
//	Modify	:	2021/09/28		bug	buffer empty
//	*******************************************************************************
inline	tstring	FD_GetSaveName	(
		HWND	hwnd
,		LPCTSTR	default_name	=	_T("")
,		LPCTSTR	filter_			=	OFN_filter_All
,		LPCTSTR title_			=	_T("Save as")
		)
{
	tstring	str_file = default_name ;
			str_file.resize(260*100) ;
	tstring	filter = filter_ ;
	if (filter.empty()) {
			filter = OFN_filter_All ;
			}
			filter   = ::String_Change(filter,_T('|'),_T('\x0')) ;
	tstring	title  = title_ ;
	{
		if (title.   size() == 0)	{	title.   resize(1) ;	}
		if (filter.  size() == 0)	{	filter.  resize(1) ;	}
		}
	OPENFILENAME	ofn =	{	0	} ;
	{
		ofn.lStructSize	= sizeof(OPENFILENAME) ;
		ofn.hwndOwner	= hwnd ;
		ofn.nMaxFile	= DWORD(str_file.size()) ;
		ofn.lpstrFile	= &str_file[0] ;
	//	ofn.Flags		= OFN_HIDEREADONLY ;
		ofn.lpstrFilter	= &filter[0] ;
		ofn.lpstrTitle	= &title[0] ;
		}
	if (!::GetSaveFileName(&ofn))		{
		DWORD	err = ::CommDlgExtendedError() ;
		if (err != 0) {
			std::terr << ::To_tstring(u_32(err),16) << std::endl ;
			}
		return	tstring() ;
		}
	tstring	sel_file ;
	{
		sel_file = ofn.lpstrFile ;
		}
	return	sel_file ;
	}

