//	*******************************************************************************
//	Name	:	c_sxt.cpp
//			:	call shell extension
//	Author	:	I. Nakagawa
//	Create	:	2021/07/06
//	Modify	:	2022/10/20
//	Modify	:	2024/12/06
//	*******************************************************************************

#include	<clocale>
#include	<iostream>

#include	"_tdefine.hxx"
#include	"cmd_line.hxx"
#include	"ask_cli.hxx"
#include	"ask_path.hxx"
#include	"pause.hxx"

////
//	*******************************************************************************
//	test function
//	Create	:	2021/07/06
//	*******************************************************************************
bool	test	(c_tstring& str)
{
	std::terr << str << std::endl ;
	return	true ;
	}

////
//	*******************************************************************************
//	call function
//	Create	:	2022/10/20
//	*******************************************************************************
inline	bool	call_func	(int argc,TCHAR* argv[])
{
	if (argc > 1) {
		for (int index=1 ; index<argc ; index++) {
			tstring	av = argv[index] ;
			::test(av) ;
			}
		}
	else {
		while(true)	{
			tstring	path ;
			{
				#ifdef	OFN_filter_All
					path = ::ask_path(false) ;
				#else
					path = ::ask_cli_path(_T("file ... ? =")) ;
				#endif
				}
			if (path.empty())	{	break ;		}
			::test(path) ;
			}
		}
	return	true ;
	}

////
//	*******************************************************************************
//	main
//	Create	:	2021/07/06
//	Modify	:	2022/10/20
//	Modify	:	2024/12/06
//	*******************************************************************************
int	_tmain	(int argc,TCHAR* argv[])
{
	_tsetlocale(LC_ALL,_T("")) ;
	{
		::reg_argv (argc,argv) ;
		}
	{
		::call_func(argc,argv) ;
		}
	{
		::test(_T("Test")) ;
		}
	::i_pause() ;
	return	0 ;
	}

//#include	"messbar.cxx"

